async function getServerVar() {
	const response = await fetch (location, {method:'HEAD'});
	const serverName = response.headers.get('server').toString();
	//console.log(serverName);
	return serverName;	
}

async function getClientIpVar(url) {
	const response = await fetch(url);
	const jsonObject = await response.json();
	//console.log(jsonObject.ip);
	return Promise.resolve(jsonObject.ip);
}

async function getDateHeader() {
	const response = await fetch (location, {method:'HEAD'});
	const DateTimeVar = response.headers.get('date').toString();
	//console.log(DateTime);
	return DateTimeVar;
}

async function getResponseCode(href) {
	const response = await fetch (href);
	const responseCodeVar = response.status
	//console.log(DateTime);
	return responseCodeVar;
}


function generateTableHead(table, data) {
  let thead = table.createTHead();
  let row = thead.insertRow();
  for (let key of data) {
    let th = document.createElement("th");
    let text = document.createTextNode(key);
    th.appendChild(text);
    row.appendChild(th);
  }
}

function generateTable(table, data) {
  for (let element of data) {
    let row = table.insertRow();
    for (key in element) {
      let cell = row.insertCell();
      let text = document.createTextNode(element[key]);
      cell.appendChild(text);
    }
  }
}

async function changeH1Tag(Status) {
	document.getElementById("H1Error").innerHTML = "Error " + Status
}

async function changePageTitle(Status) {
	document.title = Status
}

async function buildPage() {
	let serverName = await getServerVar();
	
	let clientIP = await getClientIpVar("https://api.ipify.org?format=json");

	let DateTime = await getDateHeader();
	
	let responseCode = await getResponseCode(location.href);
	
	changeH1Tag(responseCode);
	changePageTitle(responseCode);
	
	let tableData = [
		{Description: "Server Ident", Value: serverName},
		{Description: "Your IP", Value: clientIP},
		{Description: "DateTime", Value: DateTime},
		{Description: "Error", Value: responseCode},
		{Description: "URL", Value: location.href}
	];

	let table = document.querySelector("table");
	let data = Object.keys(tableData[0]);
	generateTableHead(table, data);
	generateTable(table, tableData);
}

buildPage();